<!DOCTYPE HTML>
<html>
 <head>
  <meta charset="utf-8"/>
  <title>
   Made with Remarkable!
  </title>
  <link href="http://cdnjs.cloudflare.com/ajax/libs/highlight.js/8.1/styles/github.min.css" rel="stylesheet"/>
  <style type="text/css">
   ::selection,a::selection{background:rgba(255,255,0,.3)}a,a::selection{color:#0645ad}hr,img{border:0}a,ins{text-decoration:none}::selection,ins,mark{color:#000}dfn,mark{font-style:italic}hr,ol,p,ul{margin:1em 0}table tr td,table tr th{border:1px solid #ccc;text-align:left;padding:6px 13px;margin:0}hr,pre code,table,table tr{padding:0}pre,pre code{white-space:pre}html{font-size:100%;overflow-y:scroll;-webkit-text-size-adjust:100%;-ms-text-size-adjust:100%}body{color:#444;font-family:Georgia,Palatino,"Palatino Linotype",Times,"Times New Roman",serif;font-size:12px;line-height:1.5em;padding:1em;margin:auto;max-width:42em;background:#fefefe}a:visited{color:#0b0080}a:hover{color:#06e}a:active{color:#faa700}a:focus{outline:dotted thin}a:active,a:hover{outline:0}::-moz-selection{background:rgba(255,255,0,.3);color:#000}a::-moz-selection{background:rgba(255,255,0,.3);color:#0645ad}img{max-width:100%;-ms-interpolation-mode:bicubic;vertical-align:middle}h1,h2,h3,h4,h5,h6{font-weight:400;color:#111;line-height:1em}b,h4,h5,h6,mark,strong,table tr th{font-weight:700}h1{font-size:2.5em}h2{font-size:2em}h3{font-size:1.5em}h4{font-size:1.2em}h5{font-size:1em}h6{font-size:.9em}blockquote{color:#666;margin:0;padding-left:3em;border-left:.5em #EEE solid}hr{display:block;height:2px;border-top:1px solid #aaa;border-bottom:1px solid #eee}code,kbd,pre,samp{color:#000;font-family:monospace,monospace;font-size:.98em}pre{white-space:pre-wrap;word-wrap:break-word}ins{background:#ff9}mark{background:#ff0}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sup{top:-.5em}sub{bottom:-.25em}ol,ul{padding:0 0 0 2em}li p:last-child{margin:0}dd{margin:0 0 0 2em}table{border-collapse:collapse;border-spacing:0}td{vertical-align:top}@media only screen and (min-width:480px){body{font-size:14px}}@media only screen and (min-width:768px){body{font-size:16px}}@media print{blockquote,img,pre,tr{page-break-inside:avoid}*{background:0 0!important;color:#000!important;filter:none!important;-ms-filter:none!important}body{font-size:12pt;max-width:100%}a,a:visited{text-decoration:underline}hr{height:1px;border:0;border-bottom:1px solid #000}a[href]:after{content:" (" attr(href) ")"}abbr[title]:after{content:" (" attr(title) ")"}.ir a:after,a[href^="javascript:"]:after,a[href^="#"]:after{content:""}blockquote,pre{border:1px solid #999;padding-right:1em}img{max-width:100%!important}@page :left{margin:15mm 20mm 15mm 10mm}@page :right{margin:15mm 10mm 15mm 20mm}h2,h3,p{orphans:3;widows:3}h2,h3{page-break-after:avoid}}table tr{border-top:1px solid #ccc;background-color:#fff;margin:0}table tr:nth-child(2n){background-color:#aaa}table tr td :first-child,table tr th :first-child{margin-top:0}table tr td:last-child,table tr th :last-child{margin-bottom:0}code,tt{margin:0 2px;padding:0 5px;white-space:nowrap;border:1px solid #eaeaea;background-color:#f8f8f8;border-radius:3px}pre code{margin:0;border:none;background:0 0}.highlight pre,pre{background-color:#f8f8f8;border:1px solid #ccc;font-size:13px;line-height:19px;overflow:auto;padding:6px 10px;border-radius:3px}
  </style>
 </head>
 <body>
  <h1>
   Tutorial sobre Ferramentas de Programação MicroPython para BBC Micro:bit
  </h1>
  <p>
   Recomendações :
  </p>
  <p>
   Sobre
   <a href="https://support.microbit.org/support/solutions/articles/19000013984-how-do-i-connect-the-micro-bit-to-my-computer">
    conexão de BBC Micro:bit a computador
   </a>
   . No Linux, 'usuario' precisa ter permissão no grupo 'dialout' para poder acessar dispositivo BBC Micro:bit montado em '/dev/ttyACM0'.
   <br/>
   Por exemplo, em Debian e variantes :
   <br/>
   <code>
    $ sudo usermod -a -G dialout usuario
   </code>
  </p>
  <p>
   MicroPython se diferencia da maioria das linguagens de microcontroladores por ser interpretada, permitindo interatividade elevada.
   <br/>
   Logo a sugestão é usar ferramentas de programação que incluam modo interativo (REPL).
  </p>
  <p>
   Escolha das melhores ferramentas abaixo :
  </p>
  <ul>
   <li>
    online : EduBlocks se preferir programação em blocos, senão Python Editor v2 (oficial) que suporta WebUSB (REPL, etc);
   </li>
   <li>
    offline : Mu Editor, Thonny;
   </li>
   <li>
    online &amp; simulação : create.withcode.uk.
   </li>
  </ul>
  <h1>
   Editores de Programação MicroPython para BBC Micro:bit
  </h1>
  <p>
   Há diversos editores MicroPython online e offline para BBC Micro:bit :
  </p>
  <h2>
   EduBlocks Editor : https://app.edublocks.org/
  </h2>
  <p>
   Online, tem modo para BBC Micro:bit (selecione ao iniciar), permite
   <strong>
    programação usando blocos
   </strong>
   .
   <br/>
   <a href="https://www.kitronik.co.uk/blog/getting-started-edublocks-microbit/">
    Recomendo o tutorial da Kitronik.
   </a>
  </p>
  <p>
   <img alt="EduBlocks em ação" src="https://1.bp.blogspot.com/-eyWkXGg9hGY/W3p6jKPfcxI/AAAAAAAAEE4/QXDkYy9NGeA6il8DGdXc7PSkWbQ34qtSwCEwYBhgL/s1600/Screen%2BShot%2B2018-08-20%2Bat%2B09.22.42.png" width="600"/>
  </p>
  <p>
   Dicas :
  </p>
  <ul>
   <li>
    no canto esquerdo estão as categorias de blocos, basta arrastar e ir encaixando os blocos;
   </li>
   <li>
    no canto direito superior tem botão "Blocks" e "Python" para alternar os modos de exibição de blocos e código MicroPython direto;
   </li>
   <li>
    faça transferência do arquivo .hex (firmware gerado) para o Micro:bit via botão "Download Hex", depois arraste (usando gerenciador
    <br/>
    de arquivos) para o BBC Micro:bit, mostrado como (falso) pendrive "MICROBIT";
   </li>
   <li>
    em "Settings" tem botão "Export Python" para exportar o código MicroPython em arquivo .py;
   </li>
   <li>
    em "Settings" tem botão "Flash Hex" para gravar o arquivo .hex (firmware gerado) no Micro:bit.
   </li>
  </ul>
  <h2>
   BBC Micro:bit Python Editor (oficial) : https://python.microbit.org
  </h2>
  <p>
   Online, está na versão 1.1, com algumas poucas mudanças em relação à primeiro versão.
  </p>
  <p>
   <img alt="Python Editor v1.1 para BBC Micro:bit" src="https://microbit.org/images/python-editor.png" width="600"/>
  </p>
  <p>
   Dicas :
  </p>
  <ul>
   <li>
    faça download do arquivo .hex (firmware gerado) no Micro:bit via botão "Download" no seu computador, depois arraste
    <br/>
    (usando gerenciador de arquivos) para o BBC Micro:bit, mostrado como (falso) pendrive "MICROBIT";
   </li>
   <li>
    aproveite o botão "Snippets" para inserir códigos mais usados em Python;
   </li>
   <li>
    use e abuse do botão "Help" que tem link para
    <a href="https://microbit-micropython.readthedocs.io">
     documentação de MicroPython para Micro:bit
    </a>
    ,
    <br/>
    <a href="https://python-editor-1-1-5.microbit.org/help.html">
     documentação do Python Editor para Micro:bit
    </a>
    ,
    <br/>
    bem como
    <a href="https://support.microbit.org/support/home">
     documentação geral sobre Micro:bit
    </a>
    ;
   </li>
  </ul>
  <p>
   Recomendo clicar no topo em "Python Editor beta" para acessar a prévia da
   <br/>
   <a href="https://support.microbit.org/support/solutions/articles/19000102970-python-editor-version-2-update">
    nova versão 2
   </a>
   com mais recursos :
   <br/>
   https://python.microbit.org/v/beta
   <br/>
   <img alt="Python Editor v2 para BBC Micro:bit" src="https://s3.amazonaws.com/cdn.freshdesk.com/data/helpdesk/attachments/production/19048566395/original/4sXyjuBIiVRlLVOu9wz2qK7dTg_59siXsw.png" width="600"/>
  </p>
  <p>
   Tal Python Editor v2 tem WebUSB, que deve ser compatível com o navegador web (Chrome e derivados) e permissões do sistema operacional, para que a
   <br/>
   conexão ao Micro:bit seja feita.
  </p>
  <p>
   Dicas :
  </p>
  <ul>
   <li>
    <strong>
     'auto completar'
    </strong>
    já vem habilitado (vide botão "Beta Options"), além de ter
    <strong>
     TAB para completar manualmente
    </strong>
    ;
   </li>
   <li>
    botão "Connect", se WebUSB funcionar, transforma o botão "Download" em "Flash", sem precisar usar gerenciador de arquivos;
   </li>
   <li>
    botão "Load/Save" permite ler e salvar scripts .py ou firmwares .hex, e em "Project Files" permite copiar para e do
    <br/>
    Micro:bit arquivos quaisquer (até uns 30 kB somente);
   </li>
   <li>
    botão
    <strong>
     "Open Serial" dá acesso ao modo interativo (REPL)
    </strong>
    do MicroPython no Micro:bit, se WebUSB funcionar;
   </li>
   <li>
    use e abuse do botão "Help" que tem link para
    <a href="https://microbit-micropython.readthedocs.io">
     documentação de MicroPython para Micro:bit
    </a>
    ,
    <br/>
    <a href="https://python-editor-2-0-0-beta-4.microbit.org/help.html">
     documentação do Python Editor v2 para Micro:bit
    </a>
    ,
    <br/>
    bem como
    <a href="https://support.microbit.org/support/home">
     documentação geral sobre Micro:bit
    </a>
    .
   </li>
  </ul>
  <h2>
   Mu Editor : https://codewith.mu/
  </h2>
  <p>
   <img alt="Menu do Mu Editor" src="https://codewith.mu/img/en/tutorials/mu_buttons.png" width="600"/>
  </p>
  <p>
   Offline, o melhor editor MicroPython para BBC Micro:bit em termos de recursos diversos :
  </p>
  <ul>
   <li>
    versões para
    <a href="https://codewith.mu/en/download">
     Linux, Mac OS, Raspbian, Windows
    </a>
    .
   </li>
   <li>
    em português;
   </li>
   <li>
    auto completar simples;
   </li>
   <li>
    <a href="https://codewith.mu/en/tutorials/1.0/repl">
     modo interativo (REPL)
    </a>
    opcional abaixo do modo editor;
   </li>
   <li>
    modo para transferência opcional permite copiar para e do Micro:bit arquivos quaisquer (até uns 30 kB somente);
   </li>
   <li>
    <a href="https://codewith.mu/en/tutorials/1.0/plotter">
     modo gráfico de linha(s)
    </a>
    em tempo real a partir 'print' de tupla;
   </li>
   <li>
    verificação de código;
   </li>
   <li>
    <a href="https://codewith.mu/en/tutorials/1.0/shortcuts">
     atalhos de teclado
    </a>
    ;
   </li>
   <li>
    documentação muito boa em termos de
    <a href="https://codewith.mu/en/tutorials/">
     tutoriais
    </a>
    e
    <a href="https://codewith.mu/en/howto/">
     how-to's
    </a>
    ;
   </li>
  </ul>
  <p>
   Desvantagem é a dificuldade de instalar em Linux (fora o Raspbian), que frequentemente resulta em problemas de dependências.
  </p>
  <h2>
   create.withcode.uk : https://create.withcode.uk/
  </h2>
  <p>
   Online. create.withcode.uk é editor e simulador MicroPythonand para BBC Micro:bit.
  </p>
  <p>
   <a href="https://community.computingatschool.org.uk/resources/4479/single">
    Tutorial e alguns exemplos
   </a>
   .
  </p>
  <p>
   Tem poucos recursos de edição para BBC Micro:bit :
  </p>
  <ul>
   <li>
    execução de scripts .py no simulador de BBC Micro:bit;
   </li>
   <li>
    gera firmware .hex para gravar no BBC Micro:bit;
   </li>
   <li>
    simula uso de tela de 5x5 LEDs, 2 botões, sensores, radio, etc.
   </li>
  </ul>
  <h2>
   Atom Editor : https://atom.io/
  </h2>
  <p>
   Offline. Atom é um IDE (Integrated Development Environment) multiplaforma (Linux, Mac OS, Windows), gratuito e de código-fonte aberto.
  </p>
  <p>
   Com
   <a href="https://atom.io/packages/microbit-micropython">
    plugin MicroPython para Micro:bit
   </a>
   , porém só para Linux.
  </p>
  <p>
   Tem recursos básicos para BBC Micro:bit :
  </p>
  <ul>
   <li>
    gera firmware .hex e grava no BBC Micro:bit;
   </li>
   <li>
    execução de scripts .py no BBC Micro:bit;
   </li>
   <li>
    modo interativo (REPL).
   </li>
  </ul>
  <h2>
   PyCharm : https://www.jetbrains.com/pycharm/
  </h2>
  <p>
   Offline. PyCharm é um IDE multiplaforma (Linux, Mac OS, Windows), com versão gratuita e comercial.
  </p>
  <p>
   Usando email institucional da UFES (p. e., login_no_portal_do_aluno@aluno.ufes.br), crie uma conta no site [JetBrains](https://www.jetbrains.com/] (canto superior direito). Depois clique em "Apply for a free student or teacher license for
   <br/>
   educational purposes" para se registrar em qualquer software comercial da JetBrains, incluindo PyCharm.
  </p>
  <p>
   Depois instale o
   <a href="https://github.com/vlasovskikh/intellij-micropython">
    plugin MicroPython
   </a>
   ,
   <a href="https://blog.jetbrains.com/pycharm/2018/01/micropython-plugin-for-pycharm/">
    anunciado em 2018
   </a>
   ,
   <br/>
   compatível com ESP8266, Pyboard e BBC Micro:bit.
  </p>
  <p>
   Tem os recursos mais importantes :
  </p>
  <ul>
   <li>
    auto completar e documentação de código;
   </li>
   <li>
    verificação de código;
   </li>
   <li>
    modo interativo (REPL);
   </li>
   <li>
    transferência e execução de scripts .py no microcontrolador.
   </li>
  </ul>
  <h2>
   Thonny : https://thonny.org/
  </h2>
  <p>
   <img alt="Thonny com BBC Micro:bit" src="https://bitbucket-assetroot.s3.amazonaws.com/repository/yppMM48/303187989-Variables.PNG?AWSAccessKeyId=AKIAIQWXW6WLXMB5QZAQ&amp;Expires=1570534086&amp;Signature=YJWUmNXqE%2FBmUO1c59W9wki67IM%3D" width="600"/>
  </p>
  <p>
   Offline. Thonny é um IDE para iniciantes em Python, multiplaforma (Linux, Mac OS, Windows), gratuito e de código-fonte aberto.
  </p>
  <p>
   Depois instale o
   <a href="https://bitbucket.org/KauriRaba/thonny-microbit/">
    plugin MicroPython para BBC Micro:bit
   </a>
   , vide
   <br/>
   <a href="https://bitbucket.org/KauriRaba/thonny-microbit/wiki/installation-guide">
    instruções
   </a>
   .
  </p>
  <p>
   Recursos bem amplos :
  </p>
  <ul>
   <li>
    auto completar de código;
   </li>
   <li>
    debug de variáveis;
   </li>
   <li>
    gera firmware .hex e grava no BBC Micro:bit;
   </li>
   <li>
    execução de scripts .py no BBC Micro:bit;
   </li>
   <li>
    modo interativo (REPL).
   </li>
  </ul>
  <h2>
   Visual Studio Code : https://code.visualstudio.com/
  </h2>
  <p>
   Offline. VS Code é um IDE multiplaforma (Linux, Mac OS, Windows), gratuito e de código-fonte aberto.
  </p>
  <p>
   Com
   <a href="https://marketplace.visualstudio.com/items?itemName=PhonicCanine.micro-bit">
    extensão MicroPython para Micro:bit
   </a>
   .
  </p>
  <p>
   Tem recursos limitados para BBC Micro:bit :
  </p>
  <ul>
   <li>
    auto completar de código;
   </li>
   <li>
    gera firmware .hex e grava no BBC Micro:bit.
   </li>
  </ul>
  <h1>
   Ferramentas Comando-de-Linha (CLI) de Programação MicroPython em BBC Micro:bit
  </h1>
  <p>
   Vide
   <a href="https://support.microbit.org/support/solutions/articles/19000022103-outputing-serial-data-from-the-micro-bit-to-a-computer">
    documentação sobre exibição de dados seriais do Micro:bit em computador via cabo USB serial
   </a>
   .
  </p>
  <h2>
   screen (Linux / Mac OS)
  </h2>
  <p>
   Para acesso interativo (REPL - Read Evaluate Print Loop). Usar no terminal Linux :
   <br/>
   <code>
    $ screen /dev/ttyACM0 115200
   </code>
   <br/>
   Digite enter para aparecer o prompt '&gt;&gt;&gt;', ou 'Ctrl+C' para interromper algum programa rodando.
   <br/>
   para fechar a sessão do screen no REPL, digite 'Ctrl+A' seguido de 'D'.
  </p>
  <h2>
   <a href="https://microfs.readthedocs.io/en/latest/">
    microfs/ufs
   </a>
   (Linux / Mac OS / Windows)
  </h2>
  <p>
   microfs/ufs é uma ferramenta CLI para listar, copiar e apagar arquivos do sistema de arquivos da memória flash do BBC Micro:bit.
  </p>
  <p>
   Mais exemplos na
   <a href="https://microbit-micropython.readthedocs.io/en/latest/tutorials/storage.html#file-transfer">
    documentação oficial de MicroPython para BBC Micro:bit
   </a>
   .
  </p>
  <h2>
   <a href="https://uflash.readthedocs.io/">
    uflash
   </a>
   (Linux / Mac OS / Windows)
  </h2>
  <p>
   uflash é uma ferramenta CLI para gravar e ler firmware .hex, com ou sem script MicroPython que rodará automaticamente quando o Micro:bit ligar/reiniciar.
  </p>
  <script src="http://cdnjs.cloudflare.com/ajax/libs/highlight.js/8.1/highlight.min.js">
  </script>
  <script>
   hljs.initHighlightingOnLoad();
  </script>
  <script src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML" type="text/javascript">
  </script>
  <script type="text/javascript">
   MathJax.Hub.Config({"showProcessingMessages" : false,"messageStyle" : "none","tex2jax": { inlineMath: [ [ "$", "$" ] ] }});
  </script>
 </body>
</html>